﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace marathon3_2013 {
  class Program {
    static void dumbTest(int number) {
      string filename = "C:\\Documents and Settings\\bs\\Desktop\\projects\\musala\\marathon3_2013\\marathon3_2013\\Tests\\test" + number + ".in";
      TextWriter tw = new StreamWriter(filename);
      int n, m, q;

      WebService ws = new WebService();
      ws.Init(number);



      n = ws.getRowCount();
      m = ws.getColumnCount();
      q = ws.getQueryCount();
      tw.WriteLine("" + n + " " + m + " " + q);

      string[] field = ws.getField();
      for (int i = 0; i < field.Length; ++i) {
        tw.WriteLine(field[i]);
      }

      string word = ws.nextWord();
      ws.placeWord(0, 0, false);
      tw.WriteLine(word);
      for (int i = 0; i < q - 1; ++i) {
        word = ws.nextWord();
        ws.placeWord(0, 0, false);
        tw.WriteLine(word);
      }
      long time;
      ws.EndGame(out time);
      
      tw.Close();
    }

    static StateWrapper sw;

    static bool can_place(string word, out int rx, out int ry, out bool vertical) {
      rx = 0;
      ry = 0;
      vertical = false;
      for (int x = 0; x < sw.currentField.Length; ++x) {
        for (int y = 0; y < sw.field[x].Length; ++y) {
          for (int bul4e = 0; bul4e < 2; ++bul4e) {
            bool v = (bul4e % 2 == 0);
            bool can = true;
            if (v) {
              if (x + word.Length > sw.currentField.Length) {
                can = false;
              } else {
                for (int t = 0; t < word.Length; ++t) {
                  if (sw.currentField[x + t][y] != '0' && sw.currentField[x + t][y] != word[t]) {
                    can = false;
                    break;
                  }
                }
              }
            } else {
              if (y + word.Length > sw.currentField[0].Length) {
                can = false;
              } else {
                for (int t = 0; t < word.Length; ++t) {
                  if (sw.currentField[x][y + t] != '0' && sw.currentField[x][y + t] != word[t]) {
                    can = false;
                    break;
                  }
                }
              }
            }

            if (can) {
              rx = x;
              ry = y;
              vertical = v;
              return true;
            }
          }
        }
      }
      return false;
    }

    static void solve_old() {
      while (sw.queriesMade < sw.q) {
        sw.skip();
        if (sw.queriesMade == sw.q) {
          return;
        }

        int cw = sw.currentWordIndex;

        for (int i = cw; i < sw.knownWords.Length && sw.knownWords[i] != null; ++i) {

          int x, y;
          bool v;
          if (can_place(sw.knownWords[i], out x, out y, out v)) {
            sw.nextWord();
            sw.placeWord(x, y, v);
          } else {
            sw.skip();
          }
        }
      }

    }

    static void solve_small() {
      while (sw.queriesMade < sw.q) {
        sw.skip();
        if (sw.queriesMade == sw.q) {
          return;
        }

        List<string> known_words = new List<string>();
        for (int i = sw.currentWordIndex; i < sw.knownWords.Length && sw.knownWords[i] != null; ++i) {
          known_words.Add(sw.knownWords[i]);
        }
        known_words.Sort(delegate(string a, string b) { return b.Length - a.Length; });

        Dictionary<string, Position> pos = new Dictionary<string,Position>();

        for (int i = 0; i < known_words.Count; ++i) {
          
          int x, y;
          bool v;
          if (can_place(known_words[i], out x, out y, out v)) {
            pos.Add(known_words[i], new Position(x, y, v));
            sw.executePlaceWord(known_words[i], x, y, v);
          }
        }

        int cw = sw.currentWordIndex;

        for (int i = cw; i < cw + known_words.Count && sw.queriesMade < sw.q; ++i) {
          if (!pos.ContainsKey(sw.knownWords[i])) {
            sw.skip();
          } else {
            Position p = pos[sw.knownWords[i]];
            sw.nextWord();
            sw.placeWord(p.x, p.y, p.vertical);
          }
        }
      }
    }

    static void solve_fast_few_queries() {
      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      List<KeyValuePair<int, int>>[] spots = new List<KeyValuePair<int, int>>[m + 1];
      for (int i = 1; i <= m; ++i) {
        spots[i] = new List<KeyValuePair<int, int>>();
      }
      
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
          if (sw.currentField[i][j] != '0') {
            continue;
          }

          int number = 1;
          int l;
          for (l = j + 1; l < m; ++l) {
            if (sw.currentField[i][l] != '0') {
              break;
            } else {
              number++;
            }
          }
          spots[number].Add(new KeyValuePair<int, int>(i, j));
          j = l + 1;
        }
      }

      int skipped_in_a_row = 0;
      bool rejected = false;
      while (sw.queriesMade < sw.q && skipped_in_a_row <= 10) {
        if (!rejected) {
          string word = sw.nextWord();
          bool placed = false;
          for (int l = word.Length; l <= m; ++l) {
            if (spots[l].Count > 0) {
              int index = spots[l].Count - 1;
              KeyValuePair<int, int> p = spots[l][index];
              sw.placeWord(p.Key, p.Value, false);
              if (l - word.Length > 0) {
                spots[l - word.Length].Add(new KeyValuePair<int, int>(p.Key, p.Value + word.Length));
              }
              placed = true;
              spots[l].RemoveAt(index);
              break;
            }
          }
          if (!placed) {
            rejected = true;
            sw.placeWord(0, 0, false);
          }
        } else {
          if (sw.currentWordIndex >= sw.knowWordsLen) {
            skipped_in_a_row++;
            sw.skip();
          } else {
            bool will_be_able_to_place = false;
            string word = sw.knownWords[sw.currentWordIndex];

            for (int l = word.Length; l <= m; ++l) {
              if (spots[l].Count > 0) {
                string tword = sw.nextWord();
                if (tword != word) {
                  throw new System.InvalidOperationException("inconsistent! expected: " + word + " got " + tword);
                }
                int index = spots[l].Count - 1;
                KeyValuePair<int, int> p = spots[l][index];
                skipped_in_a_row = 0;
                sw.placeWord(p.Key, p.Value, false);
                if (l - word.Length > 0) {
                  spots[l - word.Length].Add(new KeyValuePair<int, int>(p.Key, p.Value + word.Length));
                }
                spots[l].RemoveAt(index);
                will_be_able_to_place = true;
                break;
              }
            }
            if (!will_be_able_to_place) {
              skipped_in_a_row++;
              sw.skip();
            }
          }
        }
      }

      try_to_improve();
    }

    static int remove_stones() {
      int cx, cy;
      cx = 0;
      cy = 0;

      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      int stone_count = 0;
      List<KeyValuePair<int, int>> stones = new List<KeyValuePair<int, int>>();
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
          if (sw.currentField[i][j] >= '1' && sw.currentField[i][j] <= '9') {
            stone_count++;
            stones.Add(new KeyValuePair<int, int>(i, j));
          }
        }
      }

      int uptox = (stone_count - 1) / m;
      int uptoy = (stone_count + m - 1) % m;
      foreach (KeyValuePair<int, int> p in stones) {
        if (p.Key < uptox || (p.Key == uptox && p.Value <= uptoy)) {
          continue;
        }

        while (sw.currentField[cx][cy] >= '1' && sw.currentField[cx][cy] <= '9') {
          cy++;
          if (cy == m) {
            cy = 0;
            cx++;
          }
        }

        sw.relocate(p.Key, p.Value, cx, cy);
        if (sw.queriesMade >= sw.q) {
          return stone_count;
        }
      }
      return stone_count;
    }

    static void try_to_improve() {
      while (sw.queriesMade < sw.q && sw.GetElapsedMilliseconds() < 9500) {
        if (sw.currentWordIndex >= sw.knowWordsLen) {
          sw.skip();
          continue;
        }

        string word = sw.knownWords[sw.currentWordIndex];
        int x, y;
        bool v;
        //if (!try_to_fit_removing_stone()) {
        //  sw.skip();
        //}
        if (can_place(word, out x, out y, out v)) {
          sw.nextWord();
          sw.placeWord(x, y, v);
        } else {
          sw.skip();
        }
      }
    }
    static void solve_fast() {
      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      
      int stone_count = remove_stones();
      int uptox = (stone_count - 1) / m;
      int uptoy = (stone_count + m - 1)% m;
      int[] rows_free = new int[n];
      for (int i = 0; i < uptox; ++i) {
        rows_free[i] = 0;
      }
      rows_free[uptox] = m - uptoy - 1;
      for (int i = uptox + 1; i < n; ++i) {
        rows_free[i] = m;
      }

      int skipped_in_a_row = 0;
      while (sw.queriesMade < sw.q) {
        if (skipped_in_a_row > 10) {
          break;
        }
        if (sw.currentWordIndex >= sw.knowWordsLen) {
          sw.skip();
        }

        string tword = sw.knownWords[sw.currentWordIndex];
        bool good = false;
        for (int i = 0; i < n; ++i) {
          if (rows_free[i] >= tword.Length) {
            good = true;
            break;
          }
        }

        if (!good) {
          skipped_in_a_row++;
          sw.skip();
          continue;
        }
        
        string word = sw.nextWord();
        for (int i = 0; i < n; ++i) {
          if (rows_free[i] >= word.Length) {
            skipped_in_a_row = 0;
            sw.placeWord(i, m - rows_free[i], false);
            rows_free[i] -= word.Length;
            break;
          }
        }
      }

      try_to_improve();
    }

    static void solve_complete() {
      bool should_skip = false;
      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      while (sw.queriesMade < sw.q) {
        if (sw.GetElapsedMilliseconds() > 9500) {
          return;
        }
        if (sw.currentWordIndex >= sw.knowWordsLen) {
          if (should_skip) {
            sw.skip();
          } else {
            sw.nextWord();
          }
        }

        if (sw.queriesMade == sw.q) {
          break;
        }
        
        string word = sw.knownWords[sw.currentWordIndex];

        int ba = -1;
        int bi = 0;
        int bj = 0;
        bool bvert = false;
        for (int x = 0; x < n; ++x) {
          for (int y = 0; y < m; ++y) {
            for (int d = 0; d < 2; ++d) {
              bool vertical = (d % 2 == 0);
              bool valid = true;
              int added = 0;
              if (vertical) {
                if (x + word.Length > n) {
                  valid = false;
                }
                for (int i = 0; valid && i < word.Length; ++i) {
                  if (word[i] != sw.currentField[x + i][y] && sw.currentField[x + i][y] != '0') {
                    valid = false;
                  } else {
                    if (sw.currentField[x + i][y] == '0') {
                      added++;
                    }
                  }
                }
              } else {
                if (y + word.Length > m) {
                  valid = false;
                }
                for (int i = 0; valid && i < word.Length; ++i) {
                  if (word[i] != sw.currentField[x][y + i] && sw.currentField[x][y + i] != '0') {
                    valid = false;
                  } else {
                    if (sw.currentField[x][y + i] == '0') {
                      added++;
                    }
                  }
                }
              }
              if (valid) {
                if (ba == -1 || added < ba) {
                  ba = added;
                  bi = x;
                  bj = y;
                  bvert = vertical;
                }
              }
            }
          }
        }
        if (ba == -1) {
          if (should_skip == false) {
            sw.placeWord(0, 0, false);
            should_skip = true;
          } else {
            sw.skip();
          }
        } else {
          if (should_skip == true) {
            sw.nextWord();
          }
          sw.placeWord(bi, bj, bvert);
        }
      }
    }

    static bool next_permutation(List<int> l) {
      int idx = l.Count - 1;
      for (int i = l.Count - 2; i >= 0; --i) {
        if (l[i] < l[i + 1]) {
          int bi = -1;
          for (int k = i + 1; k <= idx; ++k) {
            if (l[k] > l[i]) {
              if (bi == -1 || l[bi] > l[k]) {
                bi = k;
              }
            }
          }
          int temp = l[i];
          l[i] = l[bi];
          l[bi] = temp;
          int beg = i + 1;
          int end = idx;
          while (beg < end) {
            temp = l[beg];
            l[beg] = l[end];
            l[end] = temp;
            beg++;
            end--;
          }
          return true;
        }
      }
      
      return false;
    }


    static void solve_complete_all_ways_remove_stones_first() {
      remove_stones();
      solve_complete_all_ways();
    }
    static void solve_complete_all_ways() {
      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      while (sw.queriesMade < sw.q) {
        if (sw.currentWordIndex >= sw.knowWordsLen) {
          sw.skip();
          continue;
        }

        List<string> known_words = new List<string>();
        for (int i = sw.currentWordIndex; i < sw.knowWordsLen; ++i) {
          known_words.Add(sw.knownWords[i]);
        }

        List<int> l = new List<int>();
        for (int i = 0; i < known_words.Count; ++i) {
          l.Add(i);
        }

        Solution bs =  new Solution();
        bs.letters = -1;

        bool could_not_place = false;
        do {
          Solution s = try_to_place(known_words, l);
          if (s.places.Count == 0) {
            could_not_place = true;
            break;
          }
          if (bs.letters == -1 || s.letters > bs.letters || s.letters == bs.letters && s.added < bs.added) {
            bs = s;
          }

          if (sw.GetElapsedMilliseconds() > 9500) {
            return;
          }
        } while (next_permutation(l));

        if (could_not_place) {
          solve_complete_bigger_first();
          return;
        }

        Dictionary<string, Position> pos = bs.places;

        int cw = sw.currentWordIndex;

        for (int i = cw; i < cw + known_words.Count && sw.queriesMade < sw.q; ++i) {
          if (!pos.ContainsKey(sw.knownWords[i])) {
            sw.skip();
          } else {
            Position p = pos[sw.knownWords[i]];
            sw.nextWord();
            sw.placeWord(p.x, p.y, p.vertical);
          }
        }
      }
    }

    private static Solution try_to_place(List<string> known_words, List<int> l) {
      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      List<KeyValuePair<int, int>> added_chars = new List<KeyValuePair<int, int>>();
      Solution s = new Solution();
      s.places = new Dictionary<string,Position>();

      for (int wi = 0; wi < l.Count; ++wi) {
        String word = known_words[l[wi]];
        if (sw.GetElapsedMilliseconds() > 9500) {
          return s;
        }

        int ba = -1;
        int bi = 0;
        int bj = 0;
        bool bvert = false;
        for (int x = 0; x < n; ++x) {
          for (int y = 0; y < m; ++y) {
            for (int d = 0; d < 2; ++d) {
              bool vertical = (d % 2 == 0);
              bool valid = true;
              int added = 0;
              if (vertical) {
                if (x + word.Length > n) {
                  valid = false;
                }
                for (int i = 0; valid && i < word.Length; ++i) {
                  if (word[i] != sw.currentField[x + i][y] && sw.currentField[x + i][y] != '0') {
                    valid = false;
                  } else {
                    if (sw.currentField[x + i][y] == '0') {
                      added++;
                    }
                  }
                }

              } else {
                if (y + word.Length > m) {
                  valid = false;
                }
                for (int i = 0; valid && i < word.Length; ++i) {
                  if (word[i] != sw.currentField[x][y + i] && sw.currentField[x][y + i] != '0') {
                    valid = false;
                  } else {
                    if (sw.currentField[x][y + i] == '0') {
                      added++;
                    }
                  }
                }

              }
              if (valid) {
                if (ba == -1 || added < ba) {
                  ba = added;
                  bi = x;
                  bj = y;
                  bvert = vertical;
                }
              }
            }
          }

        }
        if (ba != -1) {
          s.places.Add(word, new Position(bi, bj, bvert));
          s.added += ba;
          s.letters += word.Length;
          if (bvert) {
            for (int i = 0; i < word.Length; ++i) {
              if (sw.currentField[bi + i][bj] == '0') {
                added_chars.Add(new KeyValuePair<int, int>(bi + i, bj));
                sw.currentField[bi + i][bj] = word[i];
              }
            }
          } else {
            for (int i = 0; i < word.Length; ++i) {
              if (sw.currentField[bi][bj + i] == '0') {
                added_chars.Add(new KeyValuePair<int, int>(bi, bj + i));
                sw.currentField[bi][bj + i] = word[i];
              }
            }
          }
        }
      }

      foreach (KeyValuePair<int, int> kv in added_chars) {
        sw.currentField[kv.Key][kv.Value] = '0';
      }
      return s;
    }

    static void solve_complete_bigger_first() {
      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      while (sw.queriesMade < sw.q) {
        if (sw.currentWordIndex >= sw.knowWordsLen) {
          sw.skip();
          continue;
        }
        
        List<string> known_words = new List<string>();
        for (int i = sw.currentWordIndex; i < sw.knowWordsLen; ++i) {
          known_words.Add(sw.knownWords[i]);
        }
        known_words.Sort(delegate(string a, string b) { return b.Length - a.Length; });

        List<int> l = new List<int>();
        for (int i = 0; i < known_words.Count; ++i) {
          l.Add(i);
        }

        Solution s = try_to_place(known_words, l);
        Dictionary<string, Position> pos = s.places;
        if (pos.Count == 0) {
          bool improved = try_to_fit_removing_stone();
          if (sw.GetElapsedMilliseconds() > 9500) {
            return;
          }
          if (improved) {
            continue;
          }
        }
        int cw = sw.currentWordIndex;

        for (int i = cw; i < cw + known_words.Count && sw.queriesMade < sw.q; ++i) {
          if (!pos.ContainsKey(sw.knownWords[i])) {
            sw.skip();
          } else {
            Position p = pos[sw.knownWords[i]];
            sw.nextWord();
            sw.placeWord(p.x, p.y, p.vertical);
          }
        }
      }
    }

    private static bool try_to_fit_removing_stone() {
      int lq = sw.q - sw.queriesMade;
      List<string> optional = new List<string>();
      for (int i = sw.currentWordIndex; i < sw.knowWordsLen; ++i) {
        optional.Add(sw.knownWords[i]);
      }
      
      List<KeyValuePair<int, int>> free_spots = new List<KeyValuePair<int,int>>();
      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
          if (sw.currentField[i][j] == '0') {
            free_spots.Add(new KeyValuePair<int, int>(i, j));
          }
        }
      }

      if (free_spots.Count == 0) {
        return false;
      }

      for (int i = 0; i < optional.Count; ++i) {
        if (sw.GetElapsedMilliseconds() > 9500) {
          return false;
        }
        for (int x = 0; x < n; ++x) {
          for (int y = 0; y < m; ++y) {
            for (int v = 0; v < 2; ++v) {
              bool works = true;
              int sc = 0;
              int sx = 0;
              int sy = 0;

              if (v % 2 == 1) {
                if (x + optional[i].Length > n) {
                  continue;
                }
                for (int l = 0; l < optional[i].Length; ++l) {
                  if (sw.currentField[x + l][y] == '1') {
                    if (sc >= 1) {
                      sc++;
                      works = false;
                      break;
                    } else {
                      sc++;
                      sx = x + l;
                      sy = y;
                    }
                  } else if (sw.currentField[x + l][y] != '0' &&
                      sw.currentField[x + l][y] != optional[i][l]) {
                    works = false;
                    break;
                  }
                }
              } else {
                if (y + optional[i].Length > m) {
                  continue;
                }
                for (int l = 0; l < optional[i].Length; ++l) {
                  if (sw.currentField[x][y + l] == '1') {
                    if (sc >= 1) {
                      sc++;
                      works = false;
                      break;
                    } else {
                      sc++;
                      sx = x;
                      sy = y + l;
                    }
                  } else if (sw.currentField[x][y + l] != '0' &&
                      sw.currentField[x][y + l] != optional[i][l]) {
                    works = false;
                    break;
                  }
                }
              }

              if (!works) {
                continue;
              }

              if (sc == 0) {
                sw.nextWord();
                sw.placeWord(x, y, v % 2 == 1);
                return true;
              }

              int tx, ty;
              tx = -1;
              ty = -1;
              if (v % 2 == 1) {
                for (int it = 0; it < free_spots.Count; ++it) {
                  if (free_spots[it].Value != sy || free_spots[it].Key < x 
                      || free_spots[it].Key >= x + optional[i].Length) {
                    tx = free_spots[it].Key;
                    ty = free_spots[it].Value;
                  }
                }
              } else {
                for (int it = 0; it < free_spots.Count; ++it) {
                  if (free_spots[it].Key != sx || free_spots[it].Value < y
                      || free_spots[it].Value >= y + optional[i].Length) {
                    tx = free_spots[it].Key;
                    ty = free_spots[it].Value;
                  }
                }
              }

              if (tx != -1) {
                sw.relocate(sx, sy, tx, ty);
                while (sw.knownWords[sw.currentWordIndex] != optional[i]) {
                  sw.skip();
                }
                sw.nextWord();
                sw.placeWord(x, y, v % 2 == 1);
                return true;
              }
            }
          }
        }
      }
      return false;
    }

    static void solve_complete_bigger_first_remove_stones() {
      remove_stones();
      solve_complete_bigger_first();
    }
    static void solve() {
    //  solve_complete_all_ways();
    //  return;

      int n = sw.currentField.Length;
      int m = sw.currentField[0].Length;
      int q = sw.q;
      int total_stones = CountStones();
      bool big = false;
      bool can_solve_all_ways = false;

      if (n * m > 14400) {
        big = true;
      }
      if (n * m * q > 100 * 100 * 6000) {
        big = true;
      }

      if (!big && ((n * m)) > 5 * q) {
        solve_complete();
        return;
      }

      if (n <= 25 && m <= 25 && q <= 700) {
        can_solve_all_ways = true;
      }

      bool enough_to_remove_stones = false;
      if (n * m - total_stones <= (q - total_stones) * 3) {
        enough_to_remove_stones = true;
      }

      if (can_solve_all_ways) {
        solve_complete_all_ways();
        return;
      } 

      if (big) {
        if (enough_to_remove_stones) {
          solve_fast();
        } else {
          solve_fast_few_queries();
        }
      } else {
        if (enough_to_remove_stones) {
          solve_complete_bigger_first_remove_stones();
        } else {
          solve_complete_bigger_first();
        }
      }
    }

    static int CountStones() {
      int total_stones = 0;
      for (int i = 0; i < sw.currentField.Length; ++i) {
        for (int j = 0; j < sw.currentField[0].Length; ++j) {
          if (sw.currentField[i][j] >= '1' && sw.currentField[i][j] <= '9') {
            total_stones++;
          }
        }
      }
      return total_stones;
    }

    static void RunTest(int test_number, bool verbose) {
      bool local = false;
      sw = new StateWrapper(test_number, local);
      solve();
      sw.EndGame();

      if (local) {
        Console.WriteLine("" + test_number + ": " + "Score: " + sw.points + 
          " N: " + sw.currentField.Length + " M : " + sw.currentField[0].Length + 
          " N * M: " + sw.currentField.Length * sw.currentField[0].Length +
          " total stones: " + CountStones() + " Q: " + sw.q + " Time: " + sw.totalTime);
        if (verbose) {
          Console.WriteLine("Time: " + sw.totalTime);
          Console.WriteLine("Errors: " + sw.errors);
          sw.dumpCurrentField();

          Console.WriteLine("Total stones: " + CountStones());
        }
      }
    }
    static void Main(string[] args) {
      //for (int i = 1; i < 8; ++i) {
      //  dumbTest(i);
      //}
      String text = System.IO.File.ReadAllText("crossword.in");
      int test_number = int.Parse(text);
      //test_number = 6;

      //for (int i = 1; i <= 26; ++i) {
      //  RunTest(i, false);
      //}
      RunTest(test_number, true);
    }
  }
}



